<?php
session_start();
//RESTRICCIÓN DE ACCESO A TRABAJADOR (ACCESO INDIVIDUAL) 
if (isset($_SESSION['tipousuario']))
		{if ($_SESSION['tipousuario']=='1')
		header ('location:menu_personal.php');
		}
if  (trim($_SESSION['nombre_validar'])=='') header ('location:index.php');
set_time_limit(3000); 
include ("fphp.php");
include ("calendario/calendario.php");
$enlace=cargar_conexion();
$consulta=mysqli_query($enlace,"select * from periodo where id='".$_SESSION['id_validar']."' order by nomina,periodo desc limit 1");
if (mysqli_num_rows($consulta)!=0){
	$row=mysqli_fetch_array($consulta);
	$per=mostrar_fecha($row['desde']).' al '.mostrar_fecha($row['hasta'])." (Nom:".$row['nomina'].")";
} else $per=''; 
///////////////////////////////////////////////// inicio del programa ////////////////////////////////////////////////////////////////
$accion=$_REQUEST["accion"];
$detalle=$_REQUEST["detalle"];
menu();
echo "<b>Opciones:</b> 
&nbsp;&nbsp;<img border = 0 src='images/b_regresa.png' alt='Regresar'>:<a href='calculo_utilidades.php?'>Regresar</a>";
echo "</font><Hr>";
echo "<h2>Cierre de Utilidades Anuales</h2>";
$entra=0;

echo "<br><form name='entrada' action='".$_SERVER['PHP_SELF']."' method='POST' enctype='multipart/form-data'>
	<input type = 'hidden' name = 'graba' value = '1'>
	<table align='center'>";
			$query = "select * from nomina where id='".$_SESSION['id_validar']."' ";
			$consulta = mysqli_query($enlace,$query) or die ("no se pudo realizar la consulta...");	
			$resultado = mysqli_num_rows($consulta);
			echo "<tr><td align = 'righta'> N&oacute;mina: </td>";
			echo "<td align = 'left'> <select style='width:300px;' name = 'nomina'>";
			if ($resultado != 0) {
				for ($i=0;$i<$resultado;$i++) {
					$row1 = mysqli_fetch_array($consulta);
					echo "<option width = '30%'>".$row1['codigo']." - ".$row1['detalle'];
				}
			}	
			echo "</select>";
			echo "</td></tr>";

			echo "<tr>";
			$consulta="Select * from tablas where tabla=ucase('GERENCIA') and id='".$_SESSION['id_validar']."'  order by codigo,detalle";
			$consulta = mysqli_query($enlace,$consulta) or die ("no se pudo realizar la consulta...".$consulta.'='.mysqli_error($enlace));	
			$resultado = mysqli_num_rows($consulta);
			echo "<td align = 'righta'> Gerencia: </td>";
			echo "<td align = 'left'> <select style='width:300px;' name = 'gerencia'><option>";
			if ($resultado != 0) {
				for ($i=0;$i<$resultado;$i++) {
					$row1 = mysqli_fetch_array($consulta);
					echo "<option width = '30%'>".$row1['codigo']." - ".$row1['detalle'];
				}
			}	
			echo "</select>";
			echo "</td>";
			echo "</tr>";
								
			echo "<tr>";
			$consulta="Select * from tablas where tabla=ucase('DIVISION') and id='".$_SESSION['id_validar']."' order by codigo,detalle";
			$consulta = mysqli_query($enlace,$consulta) or die ("no se pudo realizar la consulta...".$consulta.'='.mysqli_error($enlace));	
			$resultado = mysqli_num_rows($consulta);
			echo "<td align = 'righta'> Divisi&oacute;n: </td>";
			echo "<td align = 'left'> <select style='width:300px;' name = 'division'><option>";
			if ($resultado != 0) {
				for ($i=0;$i<$resultado;$i++) {
					$row1 = mysqli_fetch_array($consulta);
					echo "<option width = '30%'>".$row1['codigo']." - ".$row1['detalle'];
				}
			}	
			echo "</select>";
			echo "</td>";
			echo "</tr>";
			
			echo "<tr>";
			$consulta="Select * from tablas where tabla=ucase('DEPARTAMENTO') and id='".$_SESSION['id_validar']."' order by codigo,detalle";
			$consulta = mysqli_query($enlace,$consulta) or die ("no se pudo realizar la consulta...".$consulta.'='.mysqli_error($enlace));	
			$resultado = mysqli_num_rows($consulta);
			echo "<td align = 'righta'> Departamento: </td>";
			echo "<td align = 'left'> <select style='width:300px;' name = 'departamento'><option>";
			if ($resultado != 0) {
				for ($i=0;$i<$resultado;$i++) {
					$row1 = mysqli_fetch_array($consulta);
					echo "<option width = '30%'>".$row1['codigo']." - ".$row1['detalle'];
				}
			}	
			echo "</select>";
			echo "</td>";
			
			echo "<tr >";
				echo "<td align = 'righta' > Fecha del Pago: </td>";
				echo "<td align = 'left'>";
						$valor = date("dmY");
						escribe_formulario_fecha_modifica("fecha","entrada",$valor);
				echo "</td>";
			echo "</tr>";
			
			echo "<tr><td align='righta'>Detalle:</td>";
			echo "<td align='left'><input style='width:300px;' name='detalle' size = '35' maxlength = '50' value='Per&iacute;odo: 01-01-".(date("Y")." al 31-12-".date("Y"))."'></td></tr>";		
			echo "<tr><td colspan='4' align='center'>";
			echo "<input name='ver' type='submit' style='margin-left:5px; height:50px; width:200px' value='Procesar Cierre'>";
			echo "</td></tr>";	
echo "</table></form></font>";

//=============================================================================== grabar cierre de utilidades
if ($accion==2 ) {
	$query = "delete from utilidades where id='".$_SESSION['id_validar']."' and detalle='".$detalle."'";
	$consulta = mysqli_query($enlace,$query) or die ("no se pudo realizar la consulta...");	
}

//=============================================================================== grabar cierre de utilidades
if ($_POST['graba']==1 ) {

	$query = "select * from utilidades where id='".$_SESSION['id_validar']."' and detalle='".$detalle."'";
	$consulta = mysqli_query($enlace,$query) or die ("no se pudo realizar la consulta...");	
	if (mysqli_num_rows($consulta)!=0) $mensaje = "Detalle existe en Historico de Utilidades Guardadas...Verifique";
	else {
	
		$fecha = crear_fecha($_POST['fecha']);
		$consulta=mysqli_query($enlace,'select * from empresa');
		if (mysqli_num_rows($consulta)!=0){
			$row=mysqli_fetch_array($consulta);
			$duti=$row['duti'];
			$ince=$row['ince'];
		}   
		
		$payroll="z_".trim($_SESSION['usuario_validar']).trim($_SESSION['id_validar']);
		$consulta=mysqli_query($enlace,"create table if not exists `".$payroll."` (
					  `cedula` varchar(8) NOT NULL,
					  `concepto` varchar(4) NOT NULL,
					  `desconcepto` varchar(50) NOT NULL,
					  `tipo` varchar(1) NOT NULL,
					  `monto` decimal(18,2) NOT NULL,
					  `saldo` decimal(18,2) NOT NULL,
					  `cantidad` decimal(18,2) NOT NULL,
					  `nomina` varchar(3) NOT NULL,
					  `desnomina` varchar(50) NOT NULL,
					  `periodo` varchar(3) NOT NULL,
					  `desperiodo` varchar(50) NOT NULL
					) ENGINE=MyISAM DEFAULT CHARSET=latin1;");
		$consulta=mysqli_query($enlace,"delete from `".$payroll."`");
		
		$query="where id='".$_SESSION['id_validar']."' and (status='A' or status='C') and nomina='".substr($_POST['nomina'],0,3)."' "; 
		if ($_POST['gerencia']!="") $query.="and gerencia='".substr($_POST['gerencia'],0,4)."' ";
		if ($_POST['division']!="") $query.="and division='".substr($_POST['division'],0,4)."' ";
		if ($_POST['departamento']!="") $query.="and departamento='".substr($_POST['departamento'],0,4)."' ";
		$queryinicial="select * from personal ".$query." order by codigo";

		//========================================================//	
		//========================================================//	
		//========================================================//
		$_POST['tipoproceso']=2;		
		include("proceso_formula.php");
		//========================================================//	
		//========================================================//	
		//========================================================//	
		
		/////////////////////////////////////////////// filtros de eliminacion INDIVIDUAL
		$query="select * from concepto_empleado where id='".$_SESSION['id_validar']."' ";
		$qempleado = mysqli_query($enlace,$query) or die ($query);
		while ($rowemp=mysqli_fetch_array($qempleado)) {
			$query="delete from $payroll where cedula='".$rowemp['cedula']."' and concepto = '".$rowemp['codigo']."'";
			$rempleado = mysqli_query($enlace,$query) or die ($query.':>'.mysqli_error($enlace));
		} // fin ciclo de concepto individual	
		/////////////////////////////////////////////// filtros de eliminacion NOMINA
		$query="select * from concepto_nomina where id='".$_SESSION['id_validar']."' ";
		$qempleado = mysqli_query($enlace,$query) or die ($query);
		while ($rowemp=mysqli_fetch_array($qempleado)) {
			$query="delete from $payroll where nomina='".$rowemp['nomina']."' and concepto = '".$rowemp['codigo']."'";
			$rempleado = mysqli_query($enlace,$query) or die ($query.':>'.mysqli_error($enlace));
		} // fin ciclo de concepto nomina	
		/////////////////////////////////////////////// filtros de eliminacion PERIODO
		$query="select * from concepto_periodo where id='".$_SESSION['id_validar']."' ";
		$qempleado = mysqli_query($enlace,$query) or die ($query);
		while ($rowemp=mysqli_fetch_array($qempleado)) {
			$query="delete from $payroll where periodo='".$rowemp['periodo']."' and concepto = '".$rowemp['codigo']."'";
			$rempleado = mysqli_query($enlace,$query) or die ($query.':>'.mysqli_error($enlace));
		} // fin ciclo de concepto periodo	
		
		/////////////////////////////////////////////// filtros de eliminacion POR MONTO = 0
		$query="delete from $payroll where monto=0";
		$qempleado = mysqli_query($enlace,$query) or die ($query);
		/////////////////////////////////////////////// filtros de eliminacion POR CONDICION
		$qpersonal = mysqli_query($enlace,$queryinicial) or die ($queryinicial.':>'.mysqli_error($enlace));
		while ($rowp = mysqli_fetch_array($qpersonal)) {
			$query="select * from concepto_condicion where id='".$_SESSION['id_validar']."' order by codigo";
			$qcondicion = mysqli_query($enlace,$query) or die ($query);
			while ($rowcondicion=mysqli_fetch_array($qcondicion)) {
				if (substr($rowcondicion['valor1'],0,1)=='C') {
					$query="select * from $payroll where cedula='".$rowp['codigo']."' and concepto = '".substr($rowcondicion['valor1'],1,4)."'";
					$qvalor = mysqli_query($enlace,$query) or die ($query.':>'.mysqli_error($enlace));
					$nvalor = mysqli_num_rows($qvalor);
					if ($nvalor==0) $monto1=0;
					else {
							$rowvalor=mysqli_fetch_array($qvalor);
							$monto1=$rowvalor['monto'];
					}
				} else $monto1 = $rowcondicion['valor1']+0;
				if (substr($rowcondicion['valor2'],0,1)=='C') {
					$query="select * from $payroll where cedula='".$rowp['codigo']."' and concepto = '".substr($rowcondicion['valor2'],1,4)."'";
					$qvalor = mysqli_query($enlace,$query) or die ($query.':>'.mysqli_error($enlace));
					$nvalor = mysqli_num_rows($qvalor);
					if ($nvalor==0) $monto2=0;
					else {
							$rowvalor=mysqli_fetch_array($qvalor);
							$monto2=$rowvalor['monto'];
					}
				} else $monto2 = $rowcondicion['valor2']+0;
				$elimina=0;

				if (trim($rowcondicion['codigo'])=='C8000' || trim($rowcondicion['codigo'])=='C8001') {
					echo $monto1."-->".$monto2;
				}
				
				if ($rowcondicion['condicion']=='=') $elimina=($monto1==$monto2)?1:0;
				if ($rowcondicion['condicion']=='<') $elimina=($monto1<$monto2)?1:0;
				if ($rowcondicion['condicion']=='>') $elimina=($monto1>$monto2)?1:0;
				if ($rowcondicion['condicion']=='>=') $elimina=($monto1>=$monto2)?1:0;
				if ($rowcondicion['condicion']=='<=') $elimina=($monto1<=$monto2)?1:0;
				if ($rowcondicion['condicion']=='<>') $elimina=($monto1!=$monto2)?1:0;
				if ($elimina == 1) {
					$query="delete from $payroll where cedula='".$rowp['codigo']."' and concepto = '".$rowcondicion['codigo']."'";
					$rempleado = mysqli_query($enlace,$query) or die ($query.':>'.mysqli_error($enlace));
				}
				} // fin ciclo de concepto condicion
		}
		/////////////////////////////////////////////// filtros de eliminacion POR SOLO UTILIDADES
		$query="select codigo,acumula from concepto where id='".$_SESSION['id_validar']."' ";
		$qempleado = mysqli_query($enlace,$query) or die ($query);
		while ($rowemp=mysqli_fetch_array($qempleado)) {
			if (trim($rowemp['acumula'])=='NO') {
				$query="delete from $payroll where concepto = '".$rowemp['codigo']."'";
				$rempleado = mysqli_query($enlace,$query) or die ($query.':>'.mysqli_error($enlace));
			}	
		} // fin ciclo de concepto periodo	
		
		
		$consulta=mysqli_query($enlace,"select * from periodo where id='".$_SESSION['id_validar']."' and nomina='".substr($_POST['nomina'],0,3)."' order by periodo DESC limit 1");
		$nomina='';$periodo='';$desnomina='';$desperiodo='';
		$nomina=substr($_POST['nomina'],0,3);
		$desnomina=substr($_POST['nomina'],6,50);
		if (mysqli_num_rows($consulta)!=0){
			$row=mysqli_fetch_array($consulta);
			$periodo=$row['periodo'];
			$_POST['cierre']=$row['pre'];
			$desperiodo=mostrar_fecha($row['desde']).' al '.mostrar_fecha($row['hasta']);
		} 
		/////////////////////////////////////////////// filtros de eliminacion POR TIPOR DE CONCEPTO = REPORTE
		$query="delete from $payroll where tipo='R'";
		$qempleado = mysqli_query($enlace,$query) or die ($query);
		$_POST['cierre']==1;
		
		/////////////////////////////////////////////// imprimir PAYROLL
		$consulta=mysqli_query($enlace,"select * from empresa where id='".$_SESSION['id_validar']."' ");
		if (mysqli_num_rows($consulta)!=0){
			$row=mysqli_fetch_array($consulta);
			$_POST['empresal']=$row['nombre'];
			$_POST['ince']=$row['ince'];
			$_POST['pie']=$row['pie'];
			$_POST['derecho']=$row['derecho'];
			$_POST['encabeza']=$row['encabeza'];
			$duti=$row['duti'];
			$_POST['empresa']=substr($_POST['nomina'],6,100);
		}   
		$_POST['periodo']=$periodo.' - '.$desperiodo;
		

		//======================================================================== grabar
		//======================================================================== grabar
		//======================================================================== grabar
		$consulta=mysqli_query($enlace,"select * from $payroll order by cedula"  );
		$linea=0;
		$color=0;
		$tasig=0;
		$tdeduc=0;
		$bandera=0;
		$ttasig=0; $ttdeduc=0; $pers=0;
		while($row=mysqli_fetch_array($consulta)) {
			$pers++;
			$ttasig+=($row['tipo']=='A'?$row['monto']:0);
			$ttdeduc+=($row['tipo']=='D'?$row['monto']:0);
			if ($bandera==0) {
				$bandera=1;
				$tcedula=$row['cedula'];
			}
			if ($tcedula==$row['cedula']) {
				$tasig+=($row['tipo']=='A'?$row['monto']:0);
				$tdeduc+=($row['tipo']=='D'?$row['monto']:0);
				$tcantidad = $row['cantidad'];
				$tmonto=$row['monto'];
				$tnombre="";
				$consul1=mysqli_query($enlace,"select nombres,apellidos,sso,gerencia,departamento,division from personal where id='".$_SESSION['id_validar']."' and codigo=".$tcedula );
				if (mysqli_num_rows($consul1)<>0) {
					$row1=mysqli_fetch_array($consul1);
					$tnombre=trim($row1['sso'])." ".trim($row1['nombres']).',  '.trim($row1['apellidos']);
					$tdep=$row1['departamento'];
					$tdiv=$row1['division'];
					$tger=$row1['gerencia'];
				}
				$tcedula=$row['cedula'];
			}	
			else {
				$linea++;				
				$consul1  ="insert into utilidades (id, cedula,fecha,detalle,departamento,gerencia,division,ince,cantidad,monto) ";
				$consul1 .="values ('".$_SESSION['id_validar']."','".$tcedula."','".$fecha."','".$_POST['detalle']."','".$tdep."','".$tger."','".$tdiv."','".$ince."','".$tcantidad."','".$tmonto."')";
				mysqli_query($enlace,$consul1) or die ($consul1.mysqli_error($enlace));
				$tasig=($row['tipo']=='A'?$row['monto']:0);
				$tdeduc=($row['tipo']=='D'?$row['monto']:0);
				$tcantidad = $row['cantidad'];
				$tmonto=$row['monto'];
				$tcedula=$row['cedula'];
				$tnombre="";
				$consul1=mysqli_query($enlace,"select nombres,apellidos,sso,gerencia,departamento,division from personal where id='".$_SESSION['id_validar']."' and codigo=".$tcedula );
				if (mysqli_num_rows($consul1)<>0) {
					$row1=mysqli_fetch_array($consul1);
					$tnombre=trim($row1['sso'])." ".trim($row1['nombres']).',  '.trim($row1['apellidos']);
					$tdep=$row1['departamento'];
					$tdiv=$row1['division'];
					$tger=$row1['gerencia'];
				}
			}
		}
		$linea++;		
		$consul1  ="insert into utilidades (id,cedula,fecha,detalle,departamento,gerencia,division,ince,cantidad,monto) ";
		$consul1 .="values ('".$_SESSION['id_validar']."','".$tcedula."','".$fecha."','".$_POST['detalle']."','".$tdep."','".$tger."','".$tdiv."','".$ince."','".$tcantidad."','".$tmonto."')";
		mysqli_query($enlace,$consul1) or die ($consul1.mysqli_error($enlace));
		$mensaje = "Cierre Efectuado...";	
	}		
} // fin del else de POST

if ($mensaje!='') echo "<center><font style='color:red; font-size:2em;' face='Verdana' ><b>".$mensaje."</b></font></center>";	

$consulta="select distinct fecha, detalle from utilidades where id='".$_SESSION['id_validar']."' order by fecha";
$resultado = mysqli_query($enlace,$consulta) or die($consulta . mysqli_error($enlace));
$num_rows = mysqli_num_rows($resultado);
if ($num_rows != 0){
		$total=0;$linea=0;
		echo "<br><table border=1 cellpadding=2 cellspacing=0 align='center'>";
		echo "<tr bgcolor='#00BFFF' >";
		echo "<th ali = center><font face='verdana' size=2> #</font></th>";
		echo "<th ali = center><font face='verdana' size=2> Fecha</font></th>";
		echo "<th ali = center><font face='verdana' size=2> Detalle</font></th>";
		echo "<th colspan=2 ali = center><font face='verdana' size=2> Elegir </font></th></tr>";
			for ($cont=0;$cont<$num_rows;$cont++) {
				$linea++;
				$color=!$color;
				if ($color) echo '<tr bgcolor="#f6f6f6" >';
				else echo '<tr bgcolor="#D8D8D8">';
				$row = mysqli_fetch_array($resultado);
				echo "<td width='50'>".$linea."</td>";
				echo "<td width='100'>".$row['fecha']."</td>";
				echo "<td width='350'>".$row['detalle']."</td>";
				if (substr($_SESSION['acceso_validar'],18,1)=='1')
				echo "<td width='30' align='center'><a onclick='return validar_elimina()' href='".$_SERVER['PHP_SELF']."?accion=2&detalle=".$row['detalle']."'><img  border = 0  src='img2/icono_07.png'alt='eliminar éste registro' ></a></td>";
				else echo "<td width='30' align='center'>&nbsp;</td>";
				
				echo "<td width='30' align='center'><a target='_blank' href='calculo_utilidades_cierre_imprimir.php?detalle=".$row['detalle']."'><img border = 0 src='img2/icono_02.png' alt='Imprimir éste registro'></a></td>";
				echo '</tr>';
			}
		echo '</tr></table></form>';
}  		
mysqli_free_result($resultado);	


?>